Summary:	x86-64/x86 Machine Check Exceptions collector and decoder
Summary(pl.UTF-8):	Narzędzie do zbierania i dekodowania wyjątków MCE na platformie x86-64/x86
Name:		mcelog
Version:	137
Release:	1
License:	GPL v2
Group:		Applications/System
#Source0Download: https://github.com/andikleen/mcelog/releases
Source0:	https://github.com/andikleen/mcelog/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	0412cc7f0169ca4fd9dde141a72dab1b
Source1:	%{name}.logrotate
Source2:	%{name}.cron
Source3:	%{name}.init
Source4:	%{name}.sysconfig
Patch1:		%{name}-FHS.patch
Patch2:		bashism.patch
URL:		http://www.mcelog.org/
BuildRequires:	rpmbuild(macros) >= 1.228
Requires(post,preun):	/sbin/chkconfig
Requires:	rc-scripts
Suggests:	crondaemon
ExclusiveArch:	%{ix86} %{x8664} x32
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		statdir		/var/lib/misc

%description
mcelog is the user space backend for logging machine check errors
reported by the hardware to the kernel. The kernel does the immediate
actions (like killing processes etc.) and mcelog decodes the logs the
errors.

Starting with version 2.6.4 for x86-64 and 2.6.32 for x86, the Linux
kernel no longer decodes and logs recoverable Machine Check Exception
events to the kernel log on its own. It is recommended that mcelog
runs on all those machines.

Instead, the MCE data is kept in a buffer which can be read from
userpace via the /dev/mcelog device node. You need this tool to
collect and decode those events; it will log the decoded MCE events
into /var/log/mcelog.

%description -l pl.UTF-8
mcelog to program do logowania błędów sprzętowych Machine Check
Exception zgłaszanych przez sprzęt (x86 i x86-64) do jądra. Jądro
podejmuje natychmiastowe akcje (takie jak odłączanie procesorów), a
mcelog dekoduje logi tych błędów.

Począwszy od wersji 2.6.4 dla x86-64 i 2.6.32 dla x86 jądro Linuksa
już samodzielnie nie dekoduje ani nie loguje niekrytycznych zdarzeń
MCE - zaleca się uruchamianie mceloga na tych wszystkich maszynach.

Zamiast logowania przez jądro, dane MCE są przechowywane w buforze,
który może być czytany z przestrzeni użytkownika poprzez urządzenie
/dev/mcelog. To narzędzie jest potrzebne do zbierania i dekodowania
tych zdarzeń; loguje ono zdekodowane zdarzenia MCE do /var/log/mcelog.

%prep
%setup -q
%patch1 -p1
%patch2 -p1

%build
%{__make} \
	CC="%{__cc}" \
	CFLAGS="%{rpmcppflags} %{rpmcflags} -fpie -pie"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/{rc.d/init.d,sysconfig,{cron,logrotate}.d},/var/log,%{statdir}}

%{__make} install \
	prefix=$RPM_BUILD_ROOT%{_prefix} \
	etcprefix=$RPM_BUILD_ROOT

cp -p %{SOURCE2} $RPM_BUILD_ROOT/etc/cron.d/%{name}
cp -p %{SOURCE1} $RPM_BUILD_ROOT/etc/logrotate.d/%{name}
install -p %{SOURCE3} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
cp -p %{SOURCE4} $RPM_BUILD_ROOT/etc/sysconfig/%{name}

:> $RPM_BUILD_ROOT%{statdir}/memory-errors

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add %{name}
%service %{name} restart

%preun
if [ "$1" = "0" ]; then
	%service -q %{name} stop
	/sbin/chkconfig --del %{name}
fi

%files
%defattr(644,root,root,755)
%doc CHANGES README TODO TODO-diskdb mce.pdf
%attr(755,root,root) %{_sbindir}/mcelog
%attr(640,root,root) /etc/cron.d/mcelog
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{name}
%config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/mcelog
%dir %{_sysconfdir}/%{name}
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/%{name}/*.conf
# do replace on upgrade, in fact, these should be moved to /lib/mcelog as they
# all support foo.local invocation at the end
%attr(755,root,root) %config %verify(not md5 mtime size) %{_sysconfdir}/%{name}/*-trigger
%attr(640,root,root) %ghost %{statdir}/memory-errors
%{_mandir}/man5/mcelog*.5*
%{_mandir}/man8/mcelog.8*
%changelog
* Sat May 21 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/mcelog.git;a=log;h=master

* Sat May 21 2016 Jakub Bogusz <qboosh@pld-linux.org> c366aae
- updated to 137

* Sat Feb 27 2016 Jan Rękorajski <baggins@pld-linux.org> 94171f9
- add x32 to supported archs
- rel 2

* Tue Feb 23 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 113e30d
- up to 132

* Thu Jun 06 2013 Jakub Bogusz <qboosh@pld-linux.org> 0f480aa
- removed obsolete todo item

* Mon Jun 03 2013 Elan Ruusamäe <glen@delfi.ee> 043645d
- use tar archive, version archives

* Mon Jun 03 2013 Elan Ruusamäe <glen@delfi.ee> 9f861ca
- no copytruncate; send a signal

* Mon Jun 03 2013 Elan Ruusamäe <glen@delfi.ee> fad3d9a
- old patch

* Sat Jun 01 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> f4c9e84
- bump rel

* Sat Jun 01 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 2b754da
- up to 20130601 snap

* Sat Nov 17 2012 Jakub Bogusz <qboosh@pld-linux.org> 319a8fe
- no reload action, so don't show it in usage

* Tue Jul 03 2012 Jakub Bogusz <qboosh@pld-linux.org> 1c3d31d
- updated pl description

* Sun Feb 05 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> b60aacd
- rel 4; drop empty config/pidfile from init file

* Wed Oct 05 2011 Elan Ruusamäe <glen@pld-linux.org> 7968f00
- add upstart config

* Tue Aug 10 2010 Elan Ruusamäe <glen@pld-linux.org> 837ee50
- "trigger" is shared with all cpus. ref: http://www.mjmwired.net/kernel/Documentation/x86/x86_64/machinecheck

* Tue Aug 10 2010 Elan Ruusamäe <glen@pld-linux.org> cb4ba1c
- release 3

* Tue Aug 10 2010 Elan Ruusamäe <glen@pld-linux.org> 9a4c45b
- avoid bash dep, rel 2

* Tue Aug 10 2010 Elan Ruusamäe <glen@pld-linux.org> 3cf9b59
- overwrite triggers on upgrade

* Tue Aug 10 2010 Elan Ruusamäe <glen@pld-linux.org> f6eacdb
- supported on ix86 since 2.6.32
  list of valid cpu's can be obtained from mcelog --help, no point keeping (outdated) list here

* Tue Aug 10 2010 Elan Ruusamäe <glen@pld-linux.org> c3921a7
- switch to daemon mode

* Tue Aug 10 2010 Elan Ruusamäe <glen@pld-linux.org> efa95c0
- daaa, /etc/mcelog is a dir!

